#include <bits/stdc++.h>
using namespace std;

int a[200005];
const int MOD = 1e9 + 7;


long long rek(int x, int y, int k){
    long long res = 0;
    if(k == 0){
        for(int i = x; i <= y; ++i){
            res += a[i];
            res %= MOD;
        }
        return res;
    }

    for(int i = x; i <= y; ++i){
        for(int j = i; j <= y; ++j){
            res += rek(i, j, k - 1);
            res %= MOD;
        }
    }

    return res;
}

int main()
{
    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }

    long long res = rek(0, n - 1, k);
    cout << res << "\n";
    return 0;
}